#include "bits/stdc++.h"

using namespace std;
#define int long long

template<typename T>
int sz(T a) {
    return (int) a.size();
}

const int maxn = 2e5 + 1, inf = 1e18;

void get_ans(int h, int w, vector<vector<int>> &a, int s, vector<int> &str, vector<int> &stolb,int sum) {
    int n = 1 << h, m = 1 << w;
    if (sum < s) {
        cout << "NO";
        return;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int u = sum;
            for (int k = 0; k < h; ++k) {
                if (i & (1 << k))
                    u -= str[k];
            }
            for (int k = 0; k < w; ++k) {
                if (j & (1 << k)) {
                    u -= stolb[k];
                }
            }
            for (int k = 0; k < h; ++k) {
                for (int l = 0; l < w; ++l) {
                    if ((i & (1 << k)) && (j & (1 << l)))
                        u += a[k][l];
                }
            }
            if (u == s) {
                cout << "YES\n";
                int cnt = 0;
                for (int k = 0; k < h; ++k) {
                    if (i & (1 << k))
                        cnt++;
                }
                for (int k = 0; k < w; ++k) {
                    if (j & (1 << k))
                        cnt++;
                }
                cout << cnt << "\n";
                for (int k = 0; k < h; ++k) {
                    if (i & (1 << k))
                        cout << "1 " << k + 1 << "\n";
                }
                for (int k = 0; k < w; ++k) {
                    if (j & (1 << k))
                        cout << "2 " << k + 1 << "\n";
                }
                return;
            }
        }
    }
    cout << "NO\n";
}

void solve() {
    int h, w;
    cin >> h >> w;

    int n = 1 << h, m = 1 << w;
    vector<vector<int>> a(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
        }
    }
    int s;
    cin >> s;
    int sum = 0;
    vector<int> str(h);
    vector<int> stolb(w);
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            str[i] += a[i][j];
            stolb[j] += a[i][j];
        }
        sum += str[i];
    }
    if (n * m <= 1000000) { get_ans(h, w, a, s, str, stolb,sum); }
    else {
        vector<vector<int>>dp(n,vector<int>(m));
        dp[0][0] = sum;
        for (int i = 1; i < n; ++i) {
            for (int j = 0; j < h; ++j) {
                if (i & (1 << j)) {
                    dp[i][0] = dp[i ^ (1 << j)][0] - str[j];
                    break;
                }
            }
        }
        for (int goofy = 0; goofy < n; ++goofy) {
            for (int i = 1; i < m; ++i) {
                for (int j = 0; j < w; ++j) {
                    if (i & (1 << j)) {
                        int u = 0;
                        for (int k = 0; k < h; ++k) {
                            if (goofy & (1 << k)) {
                                u += a[k][j];
                            }
                        }
                        dp[goofy][i] = dp[goofy][i ^ (1 << j)] - stolb[j] + u;
                        break;
                    }
                }
            }
        }

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (dp[i][j] == s) {
                    cout << "YES\n";
                    int cnt = 0;
                    for (int k = 0; k < h; ++k) {
                        if (i & (1 << k))
                            cnt++;
                    }
                    for (int k = 0; k < w; ++k) {
                        if (j & (1 << k))
                            cnt++;
                    }
                    cout << cnt << "\n";
                    for (int k = 0; k < h; ++k) {
                        if (i & (1 << k))
                            cout << "1 " << k + 1 << "\n";
                    }
                    for (int k = 0; k < w; ++k) {
                        if (j & (1 << k))
                            cout << "2 " << k + 1 << "\n";
                    }
                    return;
                }
            }
        }
        cout << "NO\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    while (_--) {
        solve();
    }
}