#include "bits/stdc++.h"

#pragma "03"
#pragma "O2"
#pragma "O3"
#pragma "unroll loops"
#pragma "unroll_loops"
using namespace std;
#define ll long long

template<typename T>
int sz(T a) {
    return (int) a.size();
}

const ll maxn = 2e5 + 1, inf = 1e18;

void solve() {
    int h, w;
    cin >> h >> w;
    int mn = inf;
    int n = 1 << h, m = 1 << w;
    ll dp[n] = {};
    ll dpp[m] = {};
    vector<vector<int>> a(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
            mn = min(a[i][j],mn);
        }
    }
    ll s;
    cin >> s;
    ll sum = 0;
    vector<ll> str(h);
    vector<ll> stolb(w);
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            str[i] += a[i][j];
            stolb[j] += a[i][j];
        }
        sum += str[i];
    }
    dp[0] = sum;
    dpp[0] = sum;
    if (sum < s || mn > s) {
        cout << "NO";
        return;
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < h; ++j) {
            if (i & (1 << j)) {
                dp[i] = dp[i ^ (1 << j)] - str[j];
                break;
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < w; ++j) {
            if (i & (1 << j)) {
                dpp[i] = dpp[i ^ (1 << j)] - stolb[j];
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (dp[i] >= s)
            for (int j = 0; j < m; ++j) {
                ll u = dp[i] + dpp[j] - sum;
                for (int l = 0; l < h; ++l) {
                    for (int k = 0; k < w; ++k) {
                        if ((i & (1 << l)) && (j & (1 << k))) {
                            u += a[l][k];
                        }
                    }
                }
                if (u == s) {
                    cout << "YES\n";
                    int cnt = 0;
                    for (int k = 0; k < h; ++k) {
                        if (i & (1 << k))
                            cnt++;
                    }
                    for (int k = 0; k < w; ++k) {
                        if (j & (1 << k))
                            cnt++;
                    }
                    cout << cnt << "\n";
                    for (int k = 0; k < h; ++k) {
                        if (i & (1 << k))
                            cout << "1 " << k + 1 << "\n";
                    }
                    for (int k = 0; k < w; ++k) {
                        if (j & (1 << k))
                            cout << "2 " << k + 1 << "\n";
                    }
                    return;
                }
            }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    while (_--) {
        solve();
    }
}