#include "bits/stdc++.h"

using namespace std;
#define int long long

template<typename T>
int sz(T a) {
    return (int) a.size();
}

const int maxn = 2e5 + 1, inf = 1e18;

void solve() {
    int h, w;
    cin >> h >> w;
    int n = 1 << h, m = 1 << w;
    vector<vector<int>> a(h, vector<int>(w));
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
        }
    }
    int s;
    cin >> s;
    int sum = 0;
    vector<int> str(h);
    vector<int> stolb(w);
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            str[i] += a[i][j];
            stolb[j] += a[i][j];
        }
        sum += str[i];
    }
    if (sum < s) {
        cout << "NO";
        return;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int u = sum;
            for (int k = 0; k < h; ++k) {
                if (i & (1 << k))
                    u -= str[k];
            }
            for (int k = 0; k < w; ++k) {
                if (j & (1 << k)) {
                    u -= stolb[k];
                }
            }
            for (int k = 0; k < h; ++k) {
                for (int l = 0; l < w; ++l) {
                    if((i & (1 << k)) && (j & (1 << l)))
                        u += a[k][l];
                }
            }
            if (u == s) {
                cout << "YES\n";
                int cnt = 0;
                for (int k = 0; k < h; ++k) {
                    if (i & (1 << k))
                        cnt++;
                }
                for (int k = 0; k < w; ++k) {
                    if (j & (1 << k))
                        cnt++;
                }
                cout << cnt << "\n";
                for (int k = 0; k < h; ++k) {
                    if (i & (1 << k))
                        cout << "1 " << k + 1 << "\n";
                }
                for (int k = 0; k < w; ++k) {
                    if (j & (1 << k))
                        cout << "2 " << k + 1 << "\n";
                }
                return;
            }
        }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    while (_--) {
        solve();
    }
}
