#include "bits/stdc++.h"

using namespace std;
#define int long long

template<typename T>
int sz(T a) {
    return (int) a.size();
}

const int maxn = 2e5 + 1, inf = 1e18;
int n, k, t;
vector<vector<int>> g;
vector<int> d;
int cnt;

void dfs(int v, int p, int o) {
    for (auto to: g[v]) {
        if (to != p) {
            if (d[v] + 1 > o) {
                cnt++;
                d[to] = 1;
            } else
                d[to] = d[v] + 1;
            dfs(to, v, o);
        }
    }
}

void bozhekakzhepihau(int v) {
    for (auto to: g[v]) {
        if (d[to] > d[v] + 1) {
            d[to] = d[v] + 1;
            bozhekakzhepihau(to);
        }
    }
}

void solve() {
    cin >> n >> k >> t;
    g.resize(n);
    bool f = true;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v, u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
        if (!(u == i && v == i + 1))
            f = false;
    }
    if (t == 1) {
        cout << "1 1 2 2 2";
    } else {
        if (k == 1 && n < 2000) {
            int ans = inf;
            for (int j = 1; j < n; ++j) {
                g[0].push_back(j);
                d.assign(n, inf);
                d[0] = 0;
                queue<int> q;
                q.push(0);
                int mn = 0;
                while (!q.empty()) {
                    int v = q.front();
                    mn = max(mn, d[v]);
                    q.pop();
                    for (auto to: g[v]) {
                        if (d[v] + 1 < d[to]) {
                            q.push(to);
                            d[to] = d[v] + 1;
                        }
                    }
                }
                ans = min(ans, mn);
                g[0].pop_back();
            }
            cout << ans << "\n";
        } else {
            int l = 0;
            int r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                cnt = 0;
                d.assign(n, 0);
                dfs(0, -1, m);
                if (cnt > k)
                    l = m;
                else
                    r = m;
            }
            cout << r << ' ';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    while (_--) {
        solve();
    }
}