#include "bits/stdc++.h"

using namespace std;
#define int long long

template<typename T>
int sz(T a) {
    return (int) a.size();
}

const int maxn = 2e5 + 1, inf = 1e18;

vector<vector<int>> g;
vector<int> d;
int cnt;

void bambuk(int v, int p, int o) {
    for (auto to: g[v]) {
        if (to != p) {
            if (d[v] + 1 > o) {
                cnt++;
                d[to] = 1;
            } else
                d[to] = d[v] + 1;
            bambuk(to, v, o);
        }
    }
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    g.resize(n);
    bool f = true;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v, u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
        if (!(u == i && v == i + 1))
            f = false;
    }
    if (f) {
        int l = 0;
        int r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            d.assign(n, 0);
            cnt = 0;
            queue<int>q;
            q.push(0);
            cnt = 0;
            for (int i = 0; i < n - 1; ++i) {
                d[i + 1] = d[i] + 1;
                if(d[i + 1] > m){
                    d[i + 1] = 1;
                    cnt++;
                }
            }
            if (cnt <= k)
                r = m;
            else
                l = m;
        }
        cout << r;
    } else {
        int ans = inf;
        for (int i = 1; i < n; ++i) {
            g[0].push_back(i);
            d.assign(n,inf);
            queue<int>q;
            q.push(0);
            int mn = 0;
            while(!q.empty()){
                int v = q.front();
                mn = max(mn, d[v]);
                q.pop();
                for(auto to: g[v]){
                    if(d[v] + 1 < d[to]){
                        d[to] = d[v] + 1;
                        q.push(to);
                    }
                }
            }
            g[0].pop_back();
            ans = min(ans, mn);
        }
        cout << ans;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    while (_--) {
        solve();
    }
}