#include "bits/stdc++.h"

using namespace std;
#define int long long

template<typename T>
int sz(T a) {
    return (int) a.size();
}

const int maxn = 2e5 + 1, inf = 1e18;
int n, k, t;
vector<vector<int>> g;
vector<int> d;
int cnt;
int mn = 0;

void dfs(int v, int p, int o) {
    for (auto to: g[v]) {
        if (to != p) {
            if (d[v] + 1 > o) {
                cnt++;
                d[to] = 1;
            } else
                d[to] = d[v] + 1;
            dfs(to, v, o);
        }
    }
}

void bozhekakzhepihau(int v, int p) {
    mn = max(mn, d[v]);
    for (auto to: g[v]) {
        if (to != p) {
            d[to] = d[v] + 1;
            bozhekakzhepihau(to,v);
        }
    }
}

void solve() {
    cin >> n >> k >> t;
    g.resize(n);
    d.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v, u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (t == 1) {
        cout << " 1 1 2 2 2";
    } else {
//        if (k > 1) {
            int l = 0;
            int r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                cnt = 0;
                d.assign(n, 0);
                dfs(0, -1, m);
                if (cnt > k)
                    l = m;
                else
                    r = m;
            }
            cout << r << ' ';
//        } else {
//            int ans = inf;
//            for (int i = 1; i < n; ++i) {
//                g[0].push_back(i);
//                bozhekakzhepihau(0,-1);
//                ans = min(ans,mn);
//                g[0].pop_back();
//            }
//        }
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    while (_--) {
        solve();
    }
}